# acmd

[![build-img]][build-url]
[![pkg-img]][pkg-url]
[![reportcard-img]][reportcard-url]
[![coverage-img]][coverage-url]

TODO

## Rationale

TODO.

## Features

* Simple API.
* Easy to integrate.
* Builtin `help` and `version` commands.
* Clean and tested code.
* Dependency-free.

## Install

Go version 1.17+

```
go get github.com/cristalhq/acmd
```

## Example

```
cmds := []acmd.Command{
	{
		Name:        "now",
		Description: "prints current time",
		Do: func(ctx context.Context, args []string) error {
			fmt.Printf("now: %s\n", now.Format("15:04:05"))
			return nil
		},
	},
	{
		Name:        "status",
		Description: "prints status of the system",
		Do: func(ctx context.Context, args []string) error {
			// do something with ctx :)
			return nil
		},
	},
}

// all the acmd.Config fields are optional
r := acmd.RunnerOf(cmds, acmd.Config{
	AppName:        "acmd-example",
	AppDescription: "Example of acmd package",
	Version:        "the best v0.x.y",
	Context:        nil,
	Args:           []string{"now"},
	Usage:          nil,
})

if err := r.Run(); err != nil {
	panic(err)
}
```

Also see examples: [examples_test.go](https://github.com/cristalhq/acmd/blob/main/example_test.go).

## Documentation

See [these docs][pkg-url].

## License

[MIT License](LICENSE).

[build-img]: https://github.com/cristalhq/acmd/workflows/build/badge.svg
[build-url]: https://github.com/cristalhq/acmd/actions
[pkg-img]: https://pkg.go.dev/badge/cristalhq/acmd
[pkg-url]: https://pkg.go.dev/github.com/cristalhq/acmd
[reportcard-img]: https://goreportcard.com/badge/cristalhq/acmd
[reportcard-url]: https://goreportcard.com/report/cristalhq/acmd
[coverage-img]: https://codecov.io/gh/cristalhq/acmd/branch/main/graph/badge.svg
[coverage-url]: https://codecov.io/gh/cristalhq/acmd
